;Stack contents:
;SS		EBP+60
;ESP		EBP+56
;EFLAGS		EBP+52
;CS		EBP+48
;EIP		EBP+44
;EC		EBP+40
;DS		EBP+38
;ES		EBP+36
;FS		EBP+34
;GS		EBP+32
;EAX		EBP+28
;ECX		EBP+24
;EDX		EBP+20
;EBX		EBP+16
;ESP (Level 0)	EBP+12
;EBP		EBP+08
;ESI		EBP+04
;EDI		SS:[EBP]
;*******************************
;DPMI services for kernel system
;*******************************

cli
push eax	;Simulate [EC]
push ds
push es
push fs
push gs
pushad
mov ebp,esp
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
and byte ptr ss:[ebp+52],0feh	;CLC
mov ax,ss:[ebp+28]
cmp ax,0ffffh
je _termirq
cmp ax,0
je _dpmiallocselectors
cmp ax,3
je _getselincvalue
cmp ax,0ch
je _copydescriptors
cmp ax,0204h
je _getirq
cmp ax,0205h
je _setirq
cmp ax,0300h
je _v86interrupt
cmp ax,0400h
je _getpics
cmp ax,0500h
je _getinfodpmi
cmp ax,0501h
je _allocatemem
push ax
mov ax,0703h
int 032h
mov wherex,0
mov wherey,3
mov esi,offset dpmiu
mov ah,3
int 032h
pop bx
mov ah,4
int 032h
jmp int21

_termirq:
mov esp,ds:tmpesp
add ds:dword ptr [offset ts],68
popad
iretd

_dpmiallocselectors:
mov bx,selptr
movzx ebx,bx
add ldtptr,ebx
mov ax,ss:[ebp+24]
mov selptr,ax		;number of selectors needed
add selact,ax
mov ax,selact
and ax,0FFF8h
or ax,7
movzx eax,ax
mov ss:[ebp+28],eax	;first selector
jmp _dpmiend

_getselincvalue:
mov dword ptr ss:[ebp+28],8
jmp _dpmiend

_copydescriptors:
mov bx,ss:[ebp+16]
movzx ebx,bx
and bx,0fff8h		;Selector value
mov esi,011a000h
add esi,ebx		;DS:[ESI]=ptr to fill
mov ax,ss:[ebp+38]
mov es,ax
mov ax,018h
mov ds,ax
mov edi,ss:[ebp]	;ES:[EDI]=ptr
mov eax,es:[edi]
mov ds:[esi],eax
mov eax,es:[edi+4]
or ah,060h		;Level 03
mov ds:[esi+4],eax
jmp _dpmiend

_v86interrupt:
mov dpmiv86,1		;V86 under DPMI
mov ax,ss:[ebp+36]	;Level 03 ES
mov es,ax
mov edi,ss:[ebp]	;Level 03 EDI,ES:EDI=Register image
mov eax,es:[edi]	;V86edi
mov v86_edi,eax
mov eax,es:[edi+4]	;V86esi
mov v86_esi,eax
mov eax,es:[edi+8]	;V86ebp
mov v86_ebp,eax
mov eax,es:[edi+16]	;V86ebx
mov v86_ebx,eax
mov eax,es:[edi+20]	;V86edx
mov v86_edx,eax
mov eax,es:[edi+24]	;V86ecx
mov v86_ecx,eax
mov eax,es:[edi+28]	;V86eax
mov v86_eax,eax
mov ax,es:[edi+32]	;Flags
mov v86_flags,ax
mov ax,es:[edi+34]	;ES
mov v86_es,ax
mov ax,es:[edi+36]	;DS
mov v86_ds,ax
mov ax,es:[edi+38]	;FS
mov v86_fs,ax
mov ax,es:[edi+40]	;GS
mov v86_gs,ax
mov ah,1
mov al,ss:[ebp+16]	;IRQ #
push ax
mov cx,018h
mov es,cx
mov ax,ss:[ebp+60]
mov dss,ax
mov ax,ss:[ebp+38]
mov dds,ax
mov ax,ss:[ebp+36]
mov des,ax
mov ax,ss:[ebp+34]
mov dfs,ax
mov ax,ss:[ebp+32]
mov dgs,ax
mov eax,ss:[ebp+56]
mov desp,eax
lidt ds:fword ptr [offset IDT_PTR]
pop ax
int 033h
cli
lidt ds:fword ptr [offset DIDT_PTR]
mov dpmiv86,0
jmp _dpmiend

_getirq:
mov esi,offset IDT_DPMI
xor ebx,ebx
mov bl,ss:[ebp+16]		;Interrupt #
shl bx,3			;*8
add esi,ebx			;Current IDT#
mov dx,ds:[esi+6]
shl edx,16
mov dx,ds:[esi]
mov cx,ds:[esi+2]
mov ss:[ebp+24],cx
mov ss:[ebp+20],edx
jmp _dpmiend

_setirq:
mov esi,offset IDT_DPMI
xor ebx,ebx
mov bl,ss:[ebp+16]
shl bx,3
add esi,ebx
mov edx,ss:[ebp+20]
mov cx,ss:[ebp+24]
mov ds:[esi],dx
shr edx,16
mov ds:[esi+6],dx
mov ds:[esi+2],cx
shl cl,5
and cl,060h		;Level 03
and byte ptr ds:[esi+5],09fh
or ds:[esi+5],cl	;Set previlegisation level
jmp _dpmiend

_getpics:
mov word ptr ss:[ebp+20],06070h		;Master=60,Slave=70 (PIC)
jmp _dpmiend

_getinfodpmi:
call near ptr _querylargest
mov bx,largest
mov dx,freesize
shr dx,2
shr bx,2
mov ax,ss:[ebp+36]
mov es,ax
mov edi,ss:[ebp]
mov es:[edi+08h],bx		;Largest lockable area (# of pages)
mov es:[edi+014h],dx
jmp _dpmiend

;Dpmi allocate memory
;BX:CX=ram needed
;The same as XMS allocation...
_allocatemem:
mov dx,ss:[ebp+16]              ;BX
shl edx,16
mov dx,ss:[ebp+24]              ;CX
shr edx,10                      ;Divide by 1024
cmp dx,freesize
jna _dpmifreememok
bts word ptr ss:[ebp+52],0      ;Set carry
jmp _dpmiend                    ;Error,Bye...
_dpmifreememok:
pushad
mov allocsize,dx
xor bx,bx
_dpmihandleloop:
inc bx
mov al,use[bx]
cmp al,1
jne _dpmifreehandleok
cmp bx,128
jne _dpmihandleloop
popad
bts word ptr ss:[ebp+52],0       ;Set carry,all handles in use
jmp _dpmiend
_dpmifreehandleok:
mov hnd,bx
cmp allocsize,0
jne _dpmidoalloc
mov use[bx],1
shl bx,1
mov sta[bx],0
mov len[bx],0
mov loc[bx],0
popad
jmp _dpmiend
_dpmidoalloc:
call near ptr _querylargest
mov ax,allocsize
cmp ax,largest
jna _dpmifreeblockok
popad
bts word ptr ss:[ebp+52],0      ;Set carry,Bye
jmp _dpmiend
_dpmifreeblockok:
mov largest,0
mov free,0
mov control,0
xor ebx,ebx
_dpmialoop:
mov esi,xmsbitmap
add esi,ebx
mov al,ds:[esi]
cmp al,1
je _dpmiastornofree
inc free
cmp control,1
je _dpminochgpos
mov position,bx
mov control,1
_dpminochgpos:
mov ax,free
cmp ax,allocsize
je _dpmipositionok
_dpmiagain:
inc bx
cmp bx,max
je _dpmiafinished
jmp _dpmialoop
_dpmiastornofree:
mov free,0
mov control,0
jmp _dpmiagain
_dpmiafinished:
popad
bts word ptr ss:[ebp+52],0
jmp _dpmiend
_dpmipositionok:
mov esi,xmsbitmap
movzx ecx,position
add esi,ecx
mov cx,allocsize
mov al,1
_dpmiallocmem:
mov ds:[esi],al
inc esi
loop _dpmiallocmem
mov ax,allocsize
sub freesize,ax
mov bx,hnd
mov handle,bx
mov use[bx],1
mov ax,position
shl bx,1
mov sta[bx],ax
mov ax,allocsize
mov len[bx],ax
xor ax,ax
mov loc[bx],ax
xor eax,eax
mov ax,sta[bx]
shl eax,10
add eax,xmsbase
mov ss:[ebp+24],ax
shr eax,16
mov ss:[ebp+16],ax
and word ptr ss:[ebp+52],0fffeh
popad
jmp _dpmiend


_dpmiend:
popad
pop gs
pop fs
pop es
pop ds
add esp,4
iretd

int21:
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
cmp handle,-1
je _nofreemem
call near ptr _freedpmimem
_nofreemem:
mov dpmirun,0
mov dword ptr ldtptr,011a000h
mov dpmiv86,0
lidt ds:fword ptr [offset IDT_PTR]
mov ah,1
mov al,021h
mov v86_ax,04c00h
int 033h

;Deallocate memory
;by the same way as the XMS
_freedpmimem:
mov dx,handle
mov handle,-1
pushad
mov hnd,dx
mov bx,dx
mov al,use[bx]
cmp al,1
je _dpmiusedok
popad
jmp _donefree
_dpmiusedok:
mov use[bx],0
shl bx,1
mov ax,len[bx]
add freesize,ax
cmp len[bx],0
je _dpminochgtable
mov esi,xmsbitmap
movzx edx,sta[bx]
add esi,edx
mov cx,len[bx]
mov len[bx],0
mov al,0
_dpmifrlp:
mov ds:[esi],al
inc esi
loop _dpmifrlp
_dpminochgtable:
popad
_donefree:
retn

dpmiu: db 'DPMI INTERFACE : UNRECOGNISED COMMAND : ',0
