;General protection handler for virtual mode

cli
pushad
mov ebp,esp
mov eax,ss:[ebp+44]	;EAX=V86EFLAGS
bt eax,17		;V8086/PMODE
jnc _proint		;PROTECTED EXCEPTION
		;EXCEPTION GENERATED FROM V86
mov ax,010h	;DATA SEGMENT
mov ds,ax
mov ax,018h
mov es,ax	;ZERO SEGMENT
;GET THE INSTRUCTION 
mov ax,ss:[ebp+44]
shr ax,1
mov debug,al
mov eax,ss:[ebp+40]	;V8086 CS
shl eax,4		;*16
add eax,ss:[ebp+36]	;+V8086 EIP
mov edi,eax
mov ebx,es:[edi]	;BL(EBX) IS THE INSTRUCTION
mov ds:v86_xxx,ebx	;STORE IT
mov ds:pref,0		;DEFAULT IS 16BIT CODE
cmp bl,066h
jne _noprefix
mov ds:pref,1
inc word ptr ss:[ebp+36] ;INCREMENT V86EIP
xchg bl,bh
_noprefix:
mov ds:v86_err,ebx
cmp bl,0ech		;IN AL,DX
je _in_al_dx
cmp bl,0eeh		;OUT DX,AL
je _out_dx_al
cmp bl,0fbh		;STI
je _sti
cmp bl,0fah		;CLI
je _cli
cmp bl,09ch		;PUSHF(D)
je _pushf
cmp bl,09dh		;POPF(D)
je _popf
cmp bl,0cdh		;INT #??
je _int
cmp bl,0cch		;INT 03
je _int03
cmp bl,0cfh		;IRET(D)
je _iret
cmp bl,0e4h
je _in_pt_al
cmp bl,0e6h
je _out_pt_al
cmp bl,0f4h		;HLT
je _hlt

mov esi,offset excmsg_d
jmp near ptr advancedf	;NONE OF THESE,DISPLAY ADVANCED TECHNICAL INFORMATION

_sti:                   
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP
mov ax,ss:[ebp+44]		;EAX=V86EFLAGS
bts ax,9
mov ss:[ebp+44],ax
jmp _ngetback			;CONTINUE V86

_cli:                   
inc word ptr ss:[ebp+36]  ;INCREMENT V86EIP
mov ax,ss:[ebp+44]	;EAX=V86EFLAGS
btr ax,9
mov ss:[ebp+44],ax
popad
add esp,4
iretd
jmp _ngetback            ;CONTINUE V86

_hlt:
mov eax,ss:[ebp+40]
cmp ax,0D000h
jne _noxmsfn
mov eax,ss:[ebp+36]
cmp ax,0
je _xmsfn
cmp ax,4
je _backtopro
cmp ax,6
je _dpmiservice
_noxmsfn:
inc word ptr ss:[ebp+36]  ;INCREMENT V86EIP
jmp _ngetback		   ;CONTINUE V86

_xmsfn:
include xms.inc

_in_al_dx:
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP
include sbread.inc

_out_dx_al:
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP
include sbwrite.inc

_out_pt_al:
inc word ptr ss:[ebp+36]		;INCREMENT V86EIP
inc word ptr ss:[ebp+36]		;(WORD INSTRUCTION)
mov ebx,ds:v86_xxx
mov bl,bh		;BL=port #
cmp bl,0a1h
je _pta1w
cmp bl,070h
je _pt70w
cmp bl,071h
je _pt71w
cmp bl,0ah
je _pt0aw
cmp bl,02h
je _pt02w
cmp bl,083h
je _pt83w
cmp bl,0ch
je _pt0cw
mov dx,bx
xor dh,dh
mov al,ss:[ebp+28]
out dx,al
jmp _ngetback
_pta1w:
in al,0a1h
and al,1
mov bl,ss:[ebp+28]
mov vpt_a1,bl
and bl,0feh
or bl,al			;Just don't stop virtual 'SB IRQ'
out 0a1h,al
jmp _ngetback
_pt70w:
mov al,ss:[ebp+28]
mov cmos,al
out 070h,al
jmp _ngetback
_pt71w:
mov al,cmos
cmp al,0ah
je _nocmosw
cmp al,0bh
je _nocmosw
mov al,ss:[ebp+28]
out 071h,al
jmp _ngetback
_nocmosw:
in al,071h
jmp _ngetback

_pt0aw:
mov al,ss:[ebp+28]
out 0ah,al
cmp al,5
jne _ngetback
;Reset DMA chn 1
;Sound Blaster emulation
mov dma_flip,0
mov dword ptr dma_base,0
mov dma_finish,0
mov dma_lnflip,0
jmp _ngetback

;Dma base address 0..16
_pt02w:
mov al,ss:[ebp+28]
out 02h,al
xor bh,bh
mov bl,dma_flip
mov dma_base[bx],al
inc dma_flip
cmp dma_flip,2
jne _ngetback
mov dma_flip,0
jmp _ngetback

_pt83w:
mov al,ss:[ebp+28]
out 083h,al
mov dma_base[2],al
jmp _ngetback

_pushf:
mov eax,ss:[ebp+52]		;EAX=V86SS
shl eax,4
add eax,ss:[ebp+48]		;EAX=LINEAR ADDRESS OF V86SS:V86ESP
mov edi,eax			;EDI=EAX
mov eax,ss:[ebp+44]		;EAX=V86EFLAGS
cmp ds:pref,1
je _double
sub edi,2
or eax,ds:testflags
mov es:[edi],ax			;PUSHF
dec ss:dword ptr [ebp+48]	;DEC V86ESP
dec ss:dword ptr [ebp+48]	;MANUALLY
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP
jmp _ngetback			;CONTINUE V86CODE...
_double:
sub edi,4
or eax,ds:testflags
and eax,047FFFh
mov es:[edi],eax		;PUSHFD
sub ss:dword ptr [ebp+48],4	;DEC V86ESP
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP (WORD INSTRUCTION)
jmp _ngetback			;CONTINUE V86CODE

_popf:
mov eax,ss:[ebp+52]		;AX=V86SS
shl eax,4
add eax,ss:[ebp+48]		;LINEAR ADDRESS OF V86 STACK
mov edi,eax
mov eax,ss:[ebp+44]		;EAX=V86EFLAGS
cmp ds:pref,1
jne _single
mov eax,es:[edi]		;EAX='POPFD' VALUE
;bts ax,9
mov ds:testflags,eax
and ds:testflags,047000h
;and ds:testflags,0ffff7000h
jmp _nextstep
_single:
xor eax,eax
mov ax,es:[edi]			;AX='POPF' VALUE
;bts ax,9
mov ds:testflags,eax
and ds:testflags,047000h
;and ds:testflags,0ffff7000h
_nextstep:
cmp ds:pref,1
je _doublepop
mov ss:[ebp+44],eax		;POPF
inc dword ptr ss:[ebp+48]	;INCREMENT V86ESP
inc dword ptr ss:[ebp+48]	;MANUALLY
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP
jmp _ngetback
_doublepop:			;POPFD
mov ss:[ebp+44],eax
add ss:dword ptr [ebp+48],4	;INCREMENT V86ESP
inc word ptr ss:[ebp+36]	;INCREMENT V86EIP
jmp _ngetback

_int:
mov ax,ss:[ebp+28]
mov ebx,ds:v86_xxx	;INSTRUCTION CODE
movzx ebx,bx
xchg bl,bh		;CHANGE OPCODE&IRQ#,BL=# OF INTERRUPT
xor bh,bh
cmp bl,021h
jne _nointdos
cmp ah,04ch
je _irqcpy
cmp ah,04bh
jne _nointdos
_irqcpy:
mov esi,0
mov edi,011F400h
mov cx,256
cpyirq:
mov eax,es:[esi]
mov es:[edi],eax
add esi,4
add edi,4
loop cpyirq
_nointdos:
cmp bl,015h
jne _noint15
mov ax,ss:[ebp+28]
cmp ah,087h
je _int15xms
cmp ah,088h
je _int15xms
cmp ah,089h
je _int15xms
_noint15:
cmp bl,02Fh
jne _nomulti
mov ax,ss:[ebp+28]
cmp ah,043h
je _xmscontrol
cmp ax,01687h
je _dpmicontrol
_nomulti:
mov eax,ss:[ebp+52]
shl eax,4
add eax,ss:[ebp+48]
mov edi,eax		;EDI=V86STACK
sub edi,2	
mov eax,ss:[ebp+44]	
or eax,testflags
bts eax,17              ;V86PUSHF TO V86STACK
mov es:[edi],ax
mov eax,ss:[ebp+40]	;EAX=V86CS
mov es:[edi-2],ax	;PUSH V86CS TO V86STACK
mov eax,ss:[ebp+36]	;EAX=V86EIP
add eax,2		;INCREMENT RETURN ADDRESS
mov es:[edi-4],ax	;PUSH V86IP TO V86STACK
sub dword ptr ss:[ebp+48],6;DEC V86ESP MANUALLY
shl bx,2		;BX=BX*4
mov edi,ebx		
mov bx,es:[edi]		;BX POINTS TO 32BIT REAL INT ADDR
movzx ebx,bx
mov ss:[ebp+36],ebx	;SET UP V86_EIP FOR INTERRUPT
mov bx,es:[edi+2]	;BX=V86CS
movzx ebx,bx
mov ss:[ebp+40],ebx	;SET UP V86_CS FOR INTERRUPT
mov eax,ss:[ebp+44]
btr eax,9
mov ss:[ebp+44],eax	;CLI
jmp _ngetback            ;CONTINUE V86CODE...


_int03:
mov eax,ss:[ebp+52]
shl eax,4
add eax,ss:[ebp+48]
mov edi,eax		;EDI=V86STACK
sub edi,2	
mov eax,ss:[ebp+44]	
or eax,testflags
bts eax,17		;V86PUSHF TO V86STACK
mov es:[edi],ax
mov eax,ss:[ebp+40]	;EAX=V86CS
mov es:[edi-2],ax	;PUSH V86CS TO V86STACK
mov eax,ss:[ebp+36]	;EAX=V86EIP
inc eax			;INCREMENT RETURN ADDRESS
mov es:[edi-4],ax	;PUSH V86IP TO V86STACK
sub dword ptr ss:[ebp+48],6 ;DEC V86ESP MANUALLY
xor ebx,ebx
mov bx,12
mov edi,ebx		
mov bx,es:[edi]		;BX POINTS TO 32BIT REAL INT ADDR
movzx ebx,bx
mov ss:[ebp+36],ebx	;SET UP V86_EIP FOR INTERRUPT
mov bx,es:[edi+2]	;BX=V86CS
movzx ebx,bx
mov ss:[ebp+40],ebx	;SET UP V86_CS FOR INTERRUPT
mov eax,ss:[ebp+44]
btr eax,9
mov ss:[ebp+44],eax	;CLI
jmp _ngetback            ;CONTINUE V86CODE...


_iret:
mov eax,ss:[ebp+52]
shl eax,4
add eax,ss:[ebp+48]
mov edi,eax             ;ES:[EDI] points to V86 STACK
xor eax,eax
mov ax,es:[edi]
mov ss:[ebp+36],eax	;POP V86EIP
xor eax,eax
mov ax,es:[edi+2]
mov ss:[ebp+40],eax	;POP V86CS
mov eax,ss:[ebp+44]
mov ax,es:[edi+4]
mov ds:testflags,eax
and ds:testflags,047000h
;and ds:testflags,0ffff7000h
;bts ax,9
mov ss:[ebp+44],eax	;POPF
add dword ptr ss:[ebp+48],6
jmp _ngetback

_in_pt_al:
inc word ptr ss:[ebp+36]
inc word ptr ss:[ebp+36]
mov edx,v86_xxx
mov dl,dh	;DL=port#
xor dh,dh
cmp dl,0a1h
je _pta1r
cmp dl,03h
je _pt03r
cmp dl,02h
je _pt02r
in al,dx
mov ss:[ebp+28],al
jmp _ngetback

_pta1r:
mov al,vpt_a1
mov ss:[ebp+28],al
jmp _ngetback

_ngetback:
mov eax,ss:[ebp+48]
and eax,0ffffh
mov ss:[ebp+48],eax
mov eax,ss:[ebp+44]	;EAX=V86EFLAGS
and eax,0fffe0FFFh
or eax,020000h
;btr eax,16		;RF
;btr eax,18		;AC=0
;bts eax,17		;VM=1
;btr ax,14		;NT=0
;bts ax,13		;IO
;bts ax,12		;PL=0
mov ss:[ebp+44],eax
rol debug,1
jc _dbg
popad
add esp,4
iretd
_dbg:
popad
add esp,4
pushad
mov cl,1
jmp _realint
_backtopro:
popad
mov v86_eax,eax
mov v86_ebx,ebx
mov v86_ecx,ecx
mov v86_edx,edx
mov v86_esi,esi
mov v86_edi,edi
mov v86_ebp,ebp
mov v86_esp,esp
pop eax		;ERROR CODE
pop eax
mov ds:v86_eip,eax
pop eax
mov ds:v86_cs,ax
pop eax
mov ds:v86_eflags,eax
pop eax
mov ds:v86_esp,eax
pop eax
mov ds:v86_ss,ax
pop eax
mov ds:v86_es,ax
pop eax
mov ds:v86_ds,ax
pop eax
mov ds:v86_fs,ax
pop eax
mov ds:v86_gs,ax
mov ax,028h
mov fs,ax
mov gs,ax
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
iretd

_proint:
mov cl,0fh
mov esi,offset excmsg_d
jmp near ptr advancedf

_int15xms:
add word ptr ss:[ebp+36],2
mov word ptr ss:[ebp+28],0
jmp _ngetback

_xmscontrol:
inc word ptr ss:[ebp+36]
inc word ptr ss:[ebp+36]
cmp al,0
je _checkxms
cmp al,010h
je _getinfo
jmp _ngetback
_checkxms:
mov word ptr ss:[ebp+28],080h
jmp _ngetback
_getinfo:
mov eax,ss:[ebp+48]
and eax,0ffffh
mov ss:[ebp+48],eax
mov ds:byte ptr [offset GDTtask+5],089h
mov eax,ss:[ebp+44]	;EAX=V86EFLAGS
btr eax,16		;RF
btr eax,18		;AC=0
bts eax,17		;VM=1
btr eax,14		;NT=0
bts eax,13		;IO
bts eax,12		;PL=0
btr eax,8
mov ss:[ebp+44],eax
mov eax,ss:[ebp+36]
and eax,0FFFFh
mov ss:[ebp+36],eax
mov eax,0d000h
mov dword ptr ss:[ebp+56],eax
popad
add esp,4
mov bx,0
iretd

_dpmicontrol:
mov word ptr ss:[ebp+28],0
mov word ptr ss:[ebp+16],1
mov cl,cputype
xor ch,ch
mov word ptr ss:[ebp+24],cx
mov word ptr ss:[ebp+20],090h
mov word ptr ss:[ebp+4],0
mov word ptr ss:[ebp+56],0D000h
mov word ptr ss:[ebp],06
jmp _ngetback

_dpmiservice:
mov handle,-1
mov esi,offset IDT_00
mov edi,offset IDT_DPMI
mov ecx,512
_makeidt:
mov eax,ds:[esi]
mov ds:[edi],eax
add esi,4
add edi,4
loop _makeidt
mov esi,offset IDT_DPMI
add esi,(031h*8+4)
mov ax,ds:[esi]
mov ah,0EEh
mov ds:[esi],ax
mov esi,offset IDT_DPMI
add esi,(021h*8+4)
mov ax,ds:[esi]
mov ah,0eeh
mov ds:[esi],ax
lidt ds:fword ptr [offset DIDT_PTR]
mov eax,ss:[ebp+52]	;SS
shl eax,4
add eax,ss:[ebp+48]	;SP
mov esi,eax		;ESI=SS:[SP]
mov bx,word ptr es:[esi]
movzx ebx,bx
mov v86_eip,ebx
xor eax,eax
mov ax,es:[esi+2]	;CS
mov edi,011a000h
mov cl,0fah
call _makesel

mov edi,011a008h
mov eax,ss:[ebp+60]	;DS
mov cl,0f2h
call _makesel

mov edi,011a010h
mov eax,ss:[ebp+56]	;ES
mov cl,0f2h
call _makesel

mov edi,011a018h
mov eax,ss:[ebp+64]	;FS
mov cl,0f2h
call _makesel

mov edi,011a020h
mov eax,ss:[ebp+68]	;GS
mov cl,0f2h
call _makesel

mov edi,011a028h	;SS
mov eax,ss:[ebp+52]
mov cl,0f2h
call _makesel
mov selptr,030h
mov selact,030h
mov dpmirun,1
mov ax,050h
lldt ax
add esp,72
mov eax,02Fh
push eax		;SS
mov eax,ss:[ebp+48]
push eax		;SP
xor eax,eax
bts eax,13
bts eax,12		;IOPL3
push eax		;EFLAGS
mov eax,07h
push eax		;CS
mov eax,v86_eip
push eax
mov ax,0Fh
mov ds,ax
mov ax,017h
mov es,ax
mov ax,01Fh
mov fs,ax
mov ax,027h
mov gs,ax
iretd

_makesel:
shl eax,4
mov bx,ax
shl ebx,16
mov bx,0ffffh		;Limit
mov es:[edi],ebx	;First four bytes
shr eax,16
xor ebx,ebx
mov bl,al		;Base
mov bh,cl		;Selector type
mov es:[edi+4],ebx
retn
