;This soubroutine handles the virtual hardware interrupts.

_realint:
	cli
        mov ebp,esp
        mov eax,ss:[ebp+40]
        bt eax,17
        jc _v8086realint

;PROTECTED MODE IRQ HANDLER
	push ds
	push es
	mov ax,010h
	mov ds,ax
	mov ax,018h
	mov es,ax
	mov ah,1
	mov al,cl
	int 033h		;Call V86 interrupt
	pop es
	pop ds
	popad
	iretd

_v8086realint:
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
mov ds:rintnum,cl
mov ds:pintnum,dl
cmp dpmiv86,1
jne _nodpmiirq
mov esi,(offset IDT_DPMI+2)
movzx eax,ds:pintnum
shl eax,3
add esi,eax
mov ax,ds:[esi]
cmp ax,8
jne _dpmiirq		;Whaww! Code8?
_nodpmiirq:
mov eax,ss:[ebp+48]
shl eax,4
add eax,ss:[ebp+44]
mov edi,eax
mov eax,ss:[ebp+40]
sub edi,2
mov es:[edi],ax
mov ax,ss:[ebp+36]
mov es:[edi-2],ax
mov eax,ss:[ebp+32]
mov es:[edi-4],ax
sub word ptr ss:[ebp+44],6        ;DEC ESP manually,STACK for IRET is OK
xor ebx,ebx
mov bl,ds:rintnum        ;BX=NUMBER OF INTERRUPT
shl bx,2
mov edi,ebx
mov bx,es:[edi]
movzx ebx,bx
mov ss:[ebp+32],ebx
mov bx,es:[edi+2]
mov ss:[ebp+36],bx ;NOW INT ADDR IS OK.
mov eax,ss:[ebp+40]
and ax,0CFFh
or eax,020000h
mov ss:[ebp+40],eax
popad
iretd

_dpmiirq:
mov tmpesp,esp
mov ds:dword ptr [offset ts],esp
;mov esi,011A000h
;movzx eax,dss
;and ax,0FFF8h
;add esi,eax
;mov eax,es:[esi]
;mov ds:dword ptr [offset GDTst],eax
;mov eax,es:[esi+4]
;mov ah,092h
;mov ds:dword ptr [offset GDTst+4],eax
mov edi,ds:desp		;ES:[EDI]=Level 03 SS:[ESP]
mov ax,dss
mov es,ax
sub edi,12
mov eax,offset _haltpm
mov es:[edi],eax
mov eax,043h
mov es:[edi+4],eax
xor eax,eax
bts eax,12
bts eax,13
mov es:[edi+8],eax
mov ax,018h
mov es,ax
mov eax,ds:dword ptr [offset GDTcode16]
mov ds:dword ptr [offset GDTcodetmp],eax
mov eax,ds:dword ptr [offset GDTcode16+4]
mov ah,0FAh
mov ds:dword ptr [offset GDTcodetmp+4],eax
movzx eax,dss
push eax
mov eax,desp
sub eax,12
push eax
xor eax,eax
bts eax,12
bts eax,13
push eax
mov esi,offset IDT_DPMI
movzx eax,ds:pintnum
shl eax,3
add esi,eax
mov ax,ds:[esi+2]
movzx eax,ax
push eax
mov ax,ds:[esi+6]
shl eax,16
mov ax,ds:[esi]
push eax
iretd

_haltpm:
mov ax,0ffffh
int 031h
