;This soubroutine handles the virtual hardware interrupts.

	cli
	pushad
        mov ebp,esp
        mov eax,ss:[ebp+40]
        bt eax,17
        jc _v8086key

;PROTECTED MODE IRQ HANDLER
	push ds
	push es
	mov ax,010h
	mov ds,ax
	mov ax,018h
	mov es,ax
	cmp exc,1
	je _prokey
	mov ah,1
	mov al,09h
	int 033h
	pop es
	pop ds
	popad
	iretd
_prokey:
        xor ecx,ecx
        xor eax,eax
        xor ebx,ebx
        in al,060h              ; get scan code
        mov bl,al
        and bl,07fh
        shl al,1
        cmc
        adc cl,0
        mov ds:[offset keybuff+bx],cl
        in      al,61h          ; get control code
        push    ax
        or      al,80h          ; clear keyboard of interrupt:
        out     61h,al          ;
        pop     ax             ;   first send control byte with inverted MSB
        out     61h,al          ;   then send plain control byte
        mov     al,20h          ; send generic EOI to
        out     20h,al          ;   PIC
	mov al,ds:keybuff[_alt]
	cmp al,1
	jne _return
	mov al,ds:keybuff[_ctrl]
	cmp al,1
	jne _return
	mov al,ds:keybuff[_del]
	cmp al,1
	jne _return
	jmp _reset
_return:
        pop es
        pop ds
        popad
        iretd		;NO IRQ HANDLINGS! Try another method!

_v8086key:
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
        xor ecx,ecx
        xor eax,eax
        xor ebx,ebx
        in al,060h              ; get scan code
        mov bl,al
        and bl,07fh
        shl al,1
        cmc
        adc cl,0
        mov ds:[offset keybuff+bx],cl
	mov al,ds:keybuff[_alt]
	cmp al,1
	jne _return2
	mov al,ds:keybuff[_ctrl]
	cmp al,1
	jne _return2
	mov al,ds:keybuff[_del]
	cmp al,1
	je _reset
	mov al,ds:keybuff[_ins]
	cmp al,1
	je _trmprg
_return2:
mov eax,ss:[ebp+48]
shl eax,4
add eax,ss:[ebp+44]
mov edi,eax
mov eax,ss:[ebp+40]
sub edi,2
mov es:[edi],ax
mov ax,ss:[ebp+36]
mov es:[edi-2],ax
mov eax,ss:[ebp+32]
mov es:[edi-4],ax
sub dword ptr ss:[ebp+44],6        ;DEC ESP manually,STACK for IRET is OK
xor ebx,ebx
mov bl,36
mov edi,ebx
mov bx,es:[edi]
movzx ebx,bx
mov ss:[ebp+32],ebx
mov bx,es:[edi+2]
mov ss:[ebp+36],bx ;NOW INT ADDR IS OK.
mov eax,ss:[ebp+40]
and ax,0CFFh
or eax,020000h
mov ss:[ebp+40],eax
popad
iretd

_reset:
cli
mov esi,011F000h
mov edi,0
mov cx,256
restoreirq:
mov eax,es:[esi]
mov es:[edi],eax
add esi,4
add edi,4
dec cx
jne restoreirq
;Close VMM file
mov al,020h
out 020h,al
out 0a0h,al
mov v86_ah,03eh
mov bx,vfhandle
mov v86_bx,bx
mov ah,1
mov al,021h
int 033h
mov bx,0870h
call near ptr _redirectirqs
mov esi,offset realcode
mov edi,09F000h
_copyreal:
mov ax,ds:[esi]
mov es:[edi],ax
add esi,2
add edi,2
cmp ax,0FFFFh
jne _copyreal
mov ax,038h
mov ds,ax
mov es,ax
mov fs,ax
mov gs,ax
mov ss,ax
mov eax,cr0
and eax,07FFFFFFFh
mov cr0,eax
xor eax,eax
mov cr3,eax
lidt cs:fword ptr [offset real_idt]
mov eax,cr0
and al,0feh
mov cr0,eax
db 0eah
dw 0
dw 09F00h
retf

realcode:
mov ax,08000h
mov ss,ax
mov esp,02000
mov ax,3
int 010h
int 019h
dd -1

_trmprg:
mov dpmiv86,0
mov keybuff[_ins],0
_waitnoins:
in al,060h
cmp al,_ins
je _waitnoins
cmp al,_alt
je _waitnoins
cmp al,_ctrl
je _waitnoins
call near ptr _freedpmimem
mov esi,011F400h
mov edi,0
mov cx,256
cpybckirq:
mov eax,es:[esi]
mov es:[edi],eax
add esi,4
add edi,4
loop cpybckirq
mov al,020h
out 020h,al
mov ah,1
mov al,010h
mov v86_ax,3
int 033h
mov ah,1
mov al,021h
mov v86_ax,04c00h
int 033h
