;XPE (Extended Power engine)
;Interrupt 33=Internal operation system functions for protected mode engine
;Copyright 1995-1996 Arnold Pkolitz

;Functions :
;01 : CALL REAL MODE INTERRUPT
;02 : CALL V86 PROCEDURE
;03 : CALL LEVEL3 16BIT PROCEDURE 

cmp ah,1
je real_interrupt
cmp ah,2
je _v86_procedure
cmp ah,3
je _readpage
cmp ah,4
je _writepage
iretd

;AH function 01 Call real mode interrupt
;AL=INTERRUPT#

real_interrupt:
mov cx,010h
mov ds,cx
mov cx,018h
mov es,cx
mov tstesp,esp
mov edi,0D0003h
mov es:[edi],al
mov ds:dword ptr [offset ts],esp
;mov ds:[GDTtask+5],089h
;mov ax,030h
;ltr ax
xor eax,eax
mov ax,v86_gs
push eax        ;GS
mov ax,v86_fs
push eax        ;FS
mov ax,v86_ds
push eax        ;DS
mov ax,v86_es
push eax        ;ES
mov eax,0D010h
push eax        ;SS
mov eax,3072
push eax        ;ESP
xor eax,eax
;btr eax,14     ;NT
;bts eax,13     ;IOPL
;bts eax,12     ;IOPL
bts eax,17     ;VM
push eax       ;EFLAGS
mov eax,0D000h
push eax        ;CS
mov eax,2
push eax        ;EIP
mov eax,ds:v86_eax
mov ebx,ds:v86_ebx
mov ecx,ds:v86_ecx
mov edx,ds:v86_edx
mov ebp,ds:v86_ebp
mov esi,ds:v86_esi
mov edi,ds:v86_edi
iretd           ;RUN V86

_proesp:  dd 0          ;SAVE REGS TO RETURN FROM V8086 MODE
_backEIP: dd 0
_backCS : dd 0
_backFL : dd 0

;AH function 02 Call V8086 procedure
;DX=SEG	V86
;CX=OFFSET V86
;RETURNS:
;DX=SEG _EXITFORMV86
;CX=OFFSET _EXITFROMV86

_V86_procedure:
mov ds:dword ptr [offset ts],esp
mov ds:byte ptr [offset GDTtask+5],089h
mov ax,030h
ltr ax
xor eax,eax
push eax        ;GS
push eax        ;FS
push eax        ;DS
push eax        ;ES
mov eax,0d000h
push eax        ;SS
mov eax,3072
push eax        ;ESP
xor eax,eax
;btr eax,14     ;NT
;bts eax,13     ;IOPL
;bts eax,12     ;IOPL
bts eax,17     ;VM
push eax       ;EFLAGS
movzx eax,dx
push eax        ;CS
movzx eax,cx
push eax        ;EIP
xor eax,eax
mov dx,0D000h
mov cx,4
iretd           ;RUN V86

_readpage:
mov al,020h
out 020h,al
out 0a0h,al
mov v86_al,0
mov v86_ah,042h
mov bx,vfhandle
mov v86_bx,bx
mov v86_dx,di
shr edi,16
mov v86_cx,di
mov ah,1
mov al,021h
int 033h	;Seek file
mov v86_ah,03fh
mov bx,vfhandle
mov v86_bx,bx
mov v86_ds,0D000h
mov v86_dx,01000h
mov v86_cx,4096
mov ah,1
mov al,021h
int 033h	;Read page to D000:1000-paged to actual place
iretd

_writepage:
mov al,020h
out 020h,al
out 0a0h,al
mov v86_al,0
mov v86_ah,042h
mov bx,vfhandle
mov v86_bx,bx
mov v86_dx,di
shr edi,16
mov v86_cx,di
mov ah,1
mov al,021h
int 033h	;Seek file
mov v86_ah,040h
mov bx,vfhandle
mov v86_bx,bx
mov v86_ds,0D000h
mov v86_dx,01000h
mov v86_cx,4096
mov ah,1
mov al,021h
int 033h	;Read page to D000:1000-paged to actual place
iretd
