;Sound Blaster port write emulation
;Copyright 1995 Kayma software

mov dx,ss:[ebp+20]
mov al,ss:[ebp+28]
cmp dx,022ch
je _22cw		;DPS Command/data register
cmp dx,0226h
je _226w		;DSP reset register (1,0)
cmp dx,0a1h
je _pta1w
cmp dx,070h
je _pt70w
cmp dx,071h
je  _pt71w
cmp dx,0ah
je _pt0aw
cmp dx,02h
je _pt02w
cmp dx,083h
je _pt83w
cmp dx,0ch
je _pt0cw
out dx,al
jmp _ngetback

_pt0cw:
mov ds:dma_lnflip,0
out 0ch,al
jmp _ngetback

;Dsp reset register
_226w:
cmp ds:sb_reset,0
je _needone		;It needs 1 to reset
cmp ds:sb_reset,1
je _needzero		;It needs 0 to reset
jmp _ngetback
_needone:
cmp al,1
jne _ngetback
mov ds:sb_reset,1
jmp _ngetback
_needzero:
cmp al,0
jne _ngetback
mov ds:sb_reset,0	;Reseted
mov ds:sb_state,0	;DSP state=0:command mode
mov ds:sb_datareq,0	;No data needed
mov ds:sb_lastcmd,0	;Last command was reset
mov ds:sb_lastdcmd,0
mov ds:sb_dmarun,0
mov ds:dma_finish,1
mov ds:sb_spk,1
mov ds:sb_timeconst,7000
mov dx,lpt
xor al,al
out dx,al
;in al,061h
;or al,3
;out 061h,al
;mov al,090h
;out 043h,al
jmp _clrdma

_22cw:
mov bl,ds:sb_state
ror bl,1
jb _sbdatas
cmp al,010h		;Command 010h Direct 8bit DAC
je _direct_8bit_dac
cmp al,0f2h     	;IRQ REQUEST
je _irq_request
cmp al,0d0h
je _hltdma
cmp al,040h
je _time_const
cmp al,014h		;DMA IRQ REQUEST
je _dma_8bit_dac
;cmp al,048h
;je _dma_dac_hi_init
;cmp al,091h
;je _dma_dac_hi_init
cmp al,0d1h
je _spkon
cmp al,0d3h
je _spkoff
cmp al,0E1h		;GET VERSION
je _get_version
cmp al,0E0h		;DSP ID
je _dsp_id		;Read data=255-write data
cmp al,080h
je _irq
cmp al,0
je _irq
push ax
mov ax,0703h
int 032h
mov wherex,0
mov wherey,0
mov ah,3
mov esi,offset _sbemu
int 032h
pop ax
xor bx,bx
mov bl,al
mov ah,4
int 032h
cli
hlt
jmp _ngetback

_dsp_id:
mov ds:sb_lastcmd,0E0h
mov ds:sb_state,1
mov ds:sb_datareq,1
jp _ngetback

_get_version:
mov ds:sb_lastcmd,0E1h
mov ds:sb_lastdcmd,0E1h
mov ds:sb_datareq,2	;2 Bytes to read SB version
jmp _ngetback

_direct_8bit_dac:
mov ds:sb_lastcmd,010h
mov ds:sb_state,1	;One data byte to the DAC
jmp _ngetback

_spkon:
mov ds:sb_lastcmd,010h
mov ds:sb_state,0
mov ds:sb_datareq,0
mov sb_spk,1
jmp _ngetback

_spkoff:
mov ds:sb_lastcmd,010h
mov ds:sb_state,0
mov ds:sb_datareq,0
mov sb_spk,0
jmp _ngetback

_time_const:
mov ds:sb_lastcmd,040h
mov ds:sb_state,1
mov ds:sb_datareq,1
jmp _ngetback

_irq_request:
mov ds:sb_lastcmd,0F2h
mov ds:sb_state,0
jmp _irq

_hltdma:
mov ds:sb_lastcmd,0d0h
mov ds:sb_state,0
mov ds:sb_dmarun,0
_clrdma:
in al,0a1h
or al,1
out 0a1h,al
mov al,0bh
out 070h,al
jmp $+2
mov al,020h
out 071h,al
jmp _ngetback

_dma_8bit_dac:
mov ds:sb_lastcmd,014h
mov ds:sb_state,1
mov ds:sb_datareq,2
jmp _ngetback

_dma_dac_hi_init:
mov ds:sb_lastcmd,048h
mov ds:sb_state,1
jmp _ngetback

_irq:
mov eax,ss:[ebp+52]
shl eax,4
add eax,ss:[ebp+48]
mov edi,eax             ;EDI=V86STACK
sub edi,2
mov eax,ss:[ebp+44]
btr eax,12
btr eax,13
btr eax,14
bts eax,17              ;V86PUSHF TO V86STACK
mov es:[edi],ax
mov eax,ss:[ebp+40]      ;EAX=V86CS
mov es:[edi-2],ax       ;PUSH V86CS TO V86STACK
mov eax,ss:[ebp+36]        ;EAX=V86EIP
mov es:[edi-4],ax       ;PUSH V86IP TO V86STACK
sub dword ptr ss:[ebp+48],6 ;DEC V86ESP MANUALLY
xor ebx,ebx
mov bl,0Fh              ;HARDWARE IRQ7=SOFTWARE IRQ 15 (LPT,SOUND BLASTER)
shl bx,2                ;BX=BX*4
mov edi,ebx
mov bx,es:[edi]         ;BX POINTS TO 32BIT REAL INT ADDR
movzx ebx,bx
mov ss:[ebp+36],ebx        ;SET UP V86_EIP FOR INTERRUPT
mov bx,es:[edi+2]       ;BX=V86CS
movzx ebx,bx
mov ss:[ebp+40],ebx      ;SET UP V86_CS FOR INTERRUPT
mov eax,ss:[ebp+44]
btr eax,9
bts eax,17
btr eax,12
btr eax,13
btr eax,14
mov ss:[ebp+44],eax
popad
add esp,4
iretd

_sbdatas:
mov ds:sb_lastdata,al
mov bl,al
mov al,ds:sb_lastcmd
cmp al,010h
je _direct_8bit_dac_data
cmp al,040h
je _time_const_data
cmp al,014h
je _dma_8bit_dac_data
cmp al,0E0h
je _dsp_id_data
jmp _ngetback

_direct_8bit_dac_data:
mov ds:sb_state,0	;Switch to command mode
;mov al,sb_spk
;ror al,1
;jnc _ngetback
mov dx,0378h		;DAC on LPT
mov al,bl		;Data byte
out dx,al
jmp _ngetback

_time_const_data:
mov ds:sb_state,0
mov ds:sb_datareq,0
mov ax,256
xor bh,bh
sub ax,bx
xor edx,edx
movzx ecx,ax
mov eax,0F4240h
div ecx			;NOW EAX=TIME CONST
mov sb_timeconst,eax
jmp _ngetback

_dsp_id_data:
mov ds:sb_state,0
mov ds:sb_datareq,0
mov ds:sb_lastdcmd,0E0h
mov ds:sb_lastdata,bl
jmp _ngetback

_dma_8bit_dac_data:
dec ds:sb_datareq
jz _chg1
;Dma size Low byte
mov al,ss:[ebp+28]
mov movedma[0],al
jmp _ngetback
_chg1:
mov al,ss:[ebp+28]
mov movedma[1],al
cmp word ptr movedma,0
jne _noincdma
mov word ptr movedma,1
mov ax,word ptr movedma
mov word ptr _movedma,ax
_noincdma:
;Dma size High byte,and back to command mode
mov ds:sb_state,0
mov ds:sb_dmactr,0
in al,0a1h
and al,0feh
out 0a1h,al
mov al,0ah
out 070h,al
jmp $+2
mov al,023h
out 071h,al
mov al,0bh
out 070h,al
jmp $+2
mov al,047h
out 071h,al
mov sb_dmarun,1
mov dma_finish,0
jmp _ngetback

_sbemu: db 'Sound Blaster Emulator : Unrecognised Command : ',0
