;Interrupt 32=Video functions for protected mode engine
;Copyright 1995-1996 Arnold Pkolitz

push ds
push es
push ax
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
pop ax
cmp ah,0
je clearscreen
cmp ah,1
je gotoxy
cmp ah,2
je writechar
cmp ah,3
je writestr
cmp ah,4
je writewordhex
cmp ah,5
je writedword
cmp ah,6
je writeword
cmp ah,7
je setvideomode
cmp ah,8
je writebin
cmp ah,9
je writebinword
cmp ah,10
je setbank
pop es
pop ds
pop ebx
mov ah,5
int 032h
pop ebx
mov ah,5
int 032h
mov bx,ss
mov ah,4
int 032h
iretd

;AH function 00 Clearscreen
;No regs changed
clearscreen:
push ax
push cx
push edi
mov wherex,0
mov wherey,0
mov edi,0b8000h
mov ah,color
mov al,20h
mov cx,2000
clr:
mov es:[edi],ax
inc edi
inc edi
loop clr
pop edi
pop cx
pop ax
pop es
pop ds
iretd

;AH function 01 gotoxy(cl,ch)
;Gotoxy (CRSR) CL=X,CH=Y coordinate,no regs change
gotoxy:
;CL=X;CH=Y coordinate
push eax
push ecx
push edx
mov wherex,cl
mov wherey,ch
xor ax,ax
mov al,wherey
mov dx,80
mul dx
xor dx,dx
mov dl,wherex
add ax,dx ;ax=coord
mov cx,ax
mov dx,03d4h
mov al,0eh
out dx,al
mov al,ch
inc dx
out dx,al
dec dx
mov al,0fh
out dx,al
mov al,cl
inc dx
out dx,al
pop edx
pop ecx
pop eax
pop es
pop ds
iretd

;AH Function 02 AL=character
;Write character at CRSR position,no regs changed

writechar:
cmp al,0
je nowrite
pushad
cmp al,0Dh
je _0d
mov edi,0B8000h
mov cl,al	;CL=CHAR TO WRITE
cmp al,9
jne _notab
mov cx,7
writetab:
mov ah,2
mov al,020h
int 032h
loop writetab
popad
jmp nowrite
_notab:
xor ax,ax
mov al,ds:wherey
mov bx,160
mul bx
xor bx,bx
mov bl,ds:wherex
add ax,bx
add di,ax
add di,bx
mov al,cl
mov ah,color
mov es:[edi],ax
inc ds:wherex
cmp ds:wherex,80
je _nxtline
jmp quit
_nxtline:
mov ds:wherex,0
inc ds:wherey
cmp ds:wherey,25
je _scroll
jmp Quit
_0d:
mov ds:wherex,0
inc ds:wherey
cmp ds:wherey,25
je _scroll
jmp quit
_scroll:
mov ds:wherey,24
mov edi,0B8000h
mov esi,0B8000h
add si,160
mov cx,1000
scr:
mov eax,es:[esi]
mov es:[edi],eax
add esi,4
add edi,4
loop scr
Quit:
;GOTOXY
xor ax,ax
mov al,wherey
mov dx,80
mul dx
xor dx,dx
mov dl,wherex
add ax,dx ;ax=coord
mov cx,ax
mov dx,03d4h
mov al,0eh
out dx,al
mov al,ch
inc dx
out dx,al
dec dx
mov al,0fh
out dx,al
mov al,cl
inc dx
out dx,al
popad
pop es
pop ds
iretd

;AH function=03h DS:[ESI]=offset string
;Write string
writestr:
pushad
mov ah,2
lp:
mov al,ds:[esi]
int 032h
inc esi
cmp al,0
jne lp
popad
pop es
pop ds
iretd

writewordhex:
mov ax,bx
mov dx,bx
shr ax,0ch
and al,0fh
cmp al,0ah
jb _0132
add al,7
_0132:
add al,030h
mov ah,2
int 032h
mov ax,dx
shr ax,08h
and al,0fh
cmp al,0ah
jb _0133
add al,7
_0133:
add al,030h
mov ah,2
int 032h
mov ax,dx
shr ax,04h
and al,0fh
cmp al,0ah
jb _0134
add al,7
_0134:
add al,030h
mov ah,2
int 032h
mov ax,dx
and al,0fh
cmp al,0ah
jb _0135
add al,7
_0135:
add al,030h
mov ah,2
int 032h
pop es
pop ds
iretd

writedword:
push ecx
push eax
mov ecx,ebx
mov ah,4
shr ebx,16
int 032h
mov ebx,ecx
mov ah,4
int 032h
pop eax
pop ecx
nowrite:
pop es
pop ds
iretd

writeword:
mov ax,bx
cmp ax,10000
jnb down1
cmp ax,1000
jnb down2
cmp ax,100
jnb down3
cmp ax,10
jnb down4
jmp down5
down1:
mov dx,0
mov cx,10000
div cx
add al,'0'
mov ah,2
int 032h
mov ax,dx
down2:
mov dx,0
mov cx,1000
div cx
add al,'0'
mov ah,2
int 032h
mov ax,dx
down3:
mov dx,0
mov cx,100
div cx
add al,'0'
mov ah,2
int 032h
mov ax,dx
down4:
mov dx,0
mov cx,10
div cx
add al,'0'
mov ah,2
int 032h
mov ax,dx
down5:
add al,'0'
mov ah,2
int 032h
pop es
pop ds
iretd

setvideomode:
pushad
mov v86_al,al
mov v86_ah,0
mov ax,0110h
int 033h
popad
pop es
pop ds
iretd

;EBX=Value
writebin:
    pushad
    mov  ah,030h
    mov  cx,32
Cikl01:
    shl  ebx,1
    mov  al,ah
    adc  al,0
push ax
mov ah,2
int 032h
pop ax
    loop Cikl01
    popad
    pop es
    pop ds
iretd

;EBX=Value
writebinword:
    pushad
    mov  ah,030h
    mov  cx,16
Cikl02:
    shl  bx,1
    mov  al,ah
    adc  al,0
push ax
mov ah,2
int 032h
pop ax
    loop Cikl02
    popad
    pop es
    pop ds
iretd


;Set VGA memory bank. Warning, TRIDENT SVGA only!
setbank:
mov ah,al
xor ah,072h
mov al,0eh
mov dx,03c4h
out dx,ax
pop es
pop ds
iretd
