;**************************************
;Kernel's include file
;XMS HANDLER
;Copyright (1995-1996) the Kayma company
;***************************************

mov eax,ss:[ebp+44]	;EAX=V86EFLAGS
and ax,00FFFh
or eax,020000h
;btr eax,16		;RF
;btr eax,18		;AC=0
;bts eax,17		;VM=1
;btr ax,14		;NT=0
;bts ax,13		;IO
;bts ax,12		;PL=0
mov ss:[ebp+44],eax
inc word ptr ss:[ebp+36]
rol debug,1
jc _dbg
popad
add esp,4
cmp ah,0
je _getversion
cmp ah,1
je _reqhma
cmp ah,2
je _relhma
cmp ah,3
je _globena20
cmp ah,4
je _globdisa20
cmp ah,5
je _locena20
cmp ah,6
je _locdisa20
cmp ah,7
je _quea20
cmp ah,8
je _queryfree
cmp ah,9
je _allocatexms
cmp ah,0ah
je _deallocatexms
cmp ah,0bh
je _movememory
cmp ah,0eh
je _gethinfo
cmp ah,010h
je _requmb
cmp ah,0ch
je _lockxms
cmp ah,0dh
je _unlockxms

pushad
push eax
mov ax,0703h
int 032h
mov wherex,0
mov wherey,0
mov esi,offset xmserr
mov ah,3
int 032h
pop eax
xor ebx,ebx
mov bl,ah
mov ah,4
int 032h
cli
hlt
iretd

_getversion:
mov ax,0300h
mov bx,0309h
mov dx,1
iretd

_querylargest:
pushad
mov largest,0
mov free,0
xor ebx,ebx
_qloop:
mov esi,xmsbitmap
add esi,ebx
mov al,ds:[esi]
cmp al,1
je _qstornofree
inc free
mov ax,free
cmp ax,largest
jna _qnolargest
mov largest,ax
_qnolargest:
inc bx
cmp bx,max
je _qfinished
jmp _qloop
_qstornofree:
mov free,0
jmp _qnolargest
_qfinished:
popad
retn

_queryfree:
call near ptr _querylargest
mov ax,largest
mov dx,freesize
iretd

_allocatexms:	;DX=Size to allocate
cmp dx,freesize
jna _freememok
xor ax,ax
mov bl,0A0h
iretd
_freememok:
pushad
mov allocsize,dx
xor bx,bx
_handleloop:
inc bx
mov al,use[bx]
cmp al,1
jne _freehandleok
cmp bx,128
jne _handleloop
popad
xor ax,ax
mov bl,0A1h	;All handles in use
iretd
_freehandleok:
mov hnd,bx
cmp allocsize,0
jne _doalloc
mov use[bx],1
shl bx,1
mov sta[bx],0
mov len[bx],0
mov loc[bx],0
popad
mov ax,1
xor bl,bl
mov dx,hnd
iretd
_doalloc:
call near ptr _querylargest
mov ax,allocsize
cmp ax,largest
jna _freeblockok
popad
xor ax,ax
mov bl,0A0h
iretd
_freeblockok:
mov largest,0
mov free,0
mov control,0
xor ebx,ebx
_aloop:
mov esi,xmsbitmap
add esi,ebx
mov al,ds:[esi]
cmp al,1
je _astornofree
inc free
cmp control,1
je _nochgpos
mov position,bx
mov control,1
_nochgpos:
mov ax,free
cmp ax,allocsize
je _positionok
_again:
inc bx
cmp bx,max
je _afinished
jmp _aloop
_astornofree:
mov free,0
mov control,0
jmp _again
_afinished:
popad
xor ax,ax
mov bl,0A0h
iretd
_positionok:
mov esi,xmsbitmap
movzx ecx,position
add esi,ecx
mov cx,allocsize
mov al,1
_allocmem:
mov ds:[esi],al
inc esi
loop _allocmem
mov ax,allocsize
sub freesize,ax
mov bx,hnd
mov use[bx],1
mov ax,position
shl bx,1
mov sta[bx],ax
mov ax,allocsize
mov len[bx],ax
xor ax,ax
mov loc[bx],ax
popad
mov ax,1
xor bl,bl
mov dx,hnd
iretd


_deallocatexms:
pushad
mov hnd,dx
mov bx,dx
mov al,use[bx]
cmp al,1
je _usedok
popad
xor ax,ax
mov bl,0A2h
iretd
_usedok:
mov use[bx],0
shl bx,1
mov ax,len[bx]
add freesize,ax
cmp len[bx],0
je _nochgtable
mov esi,xmsbitmap
movzx edx,sta[bx]
add esi,edx
mov cx,len[bx]
mov len[bx],0
mov al,0
_frlp:
mov ds:[esi],al
inc si
loop _frlp
_nochgtable:
popad
mov ax,1
xor bl,bl
iretd

_movememory:
pushad
mov ebp,esp
xor eax,eax
xor ecx,ecx
mov ax,ss:[ebp+56]
shl eax,4
mov cx,ss:[ebp+4]
add eax,ecx
mov edi,eax	;EDI points to the structure
mov eax,es:[edi]
cmp eax,0
ja _msizeok
popad
mov ax,1
xor bl,bl
iretd
_msizeok:
mov ebx,eax
and bl,1
cmp bl,1
jne _alignok
popad
xor ax,ax
mov bl,0A7h
iretd
_alignok:
mov movelen,eax		;Size to transfer
mov ax,es:[edi+4]
mov sourceh,ax
mov eax,es:[edi+6]
mov sourceo,eax
mov ax,es:[edi+10]
mov desth,ax
mov eax,es:[edi+12]
mov desto,eax
mov ax,sourceh
cmp ax,0
jne _mcont1		
xor ebx,ebx		;Source is real
mov eax,sourceo
mov ecx,eax
shr eax,16		;AX=SEG
shl eax,4		;Destroy lower bits
mov bx,cx		;BX=OFFSET
add ebx,eax
mov sourceo,ebx
jmp _mcont2
_mcont1:
mov ecx,sourceo
add ecx,movelen
xor eax,eax
mov bx,sourceh
shl bx,1
mov ax,len[bx]
cmp ax,0
je _nomove
shl eax,10
cmp ecx,eax
jna _sizeo1
popad		;Segment violation
xor ax,ax
mov bl,0a7h
iretd
_sizeo1:
mov bx,sourceh
shl bx,1
xor eax,eax
mov ax,len[bx]
shl eax,10
cmp eax,movelen
jnb _sizeok2
popad
xor ax,ax
mov bl,0a7h
iretd
_sizeok2:
mov bx,sourceh
mov al,use[bx]
cmp al,1
je _ok1
popad
xor ax,ax
mov bl,0A3h		;Invalid sourcehandle
iretd
_ok1:			;Handle is in use
shl bx,1
mov ax,loc[bx]		;Locked block?
shr bx,1
cmp al,0
je _noloc1
popad
xor ax,ax
mov bl,0ABh
iretd
_noloc1:
mov bx,sourceh
shl bx,1
xor eax,eax
mov ax,sta[bx]
shl eax,10	;x*1024 Kb
add eax,xmsbase
add sourceo,eax
_mcont2:
mov ax,desth
cmp ax,0
jne _dmcont1		
xor ebx,ebx		;Destination is real
mov eax,desto
mov ecx,eax
shr eax,16		;AX=SEG
shl eax,4		;Destroy lower bits
mov bx,cx		;BX=OFFSET
add ebx,eax
mov desto,ebx
jmp _dmcont2
_dmcont1:
mov ecx,desto
add ecx,movelen
mov bx,desth
shl bx,1
xor eax,eax
mov ax,len[bx]
cmp ax,0
je _nomove
shl eax,10
cmp ecx,eax
jna _dsizeo1
popad
xor ax,ax
mov bl,0a7h
iretd
_dsizeo1:
mov bx,desth
shl bx,1
xor eax,eax
mov ax,len[bx]
shl eax,10
cmp eax,movelen
jnb _sizeok3
popad
xor ax,ax
mov bl,0a7h
iretd
_sizeok3:
mov bx,desth
mov al,use[bx]
cmp al,1
je _dok1
popad
xor ax,ax
mov bl,0A5h		;Invalid desthandle
iretd
_dok1:			;Handle is in use
shl bx,1
mov ax,loc[bx]
shr bx,1
cmp al,1
jne _noloc2
popad
xor ax,ax
mov bl,0ABh
iretd
_noloc2:
mov bx,desth
shl bx,1
xor eax,eax
mov ax,sta[bx]
shl eax,10	;x*1024 Kb
add eax,xmsbase
add desto,eax
_dmcont2:
mov ecx,movelen
shr ecx,1
mov esi,sourceo
mov edi,desto
_trans:
mov ax,es:[esi]
mov es:[edi],ax
add esi,2
add edi,2
loop _trans
popad
mov ax,1
xor bl,bl
iretd

_nomove:
popad
mov ax,0
mov bl,0a2h
iretd

_gethinfo:
cmp dx,0
jne _handlevalid1
xor ax,ax
mov bl,0a2h
iretd
_handlevalid1:
cmp dx,128
jna _handlevalid2
xor ax,ax
mov bl,0a2h
iretd
_handlevalid2:
pushad
mov hnd,dx
xor bx,bx
mov free,0
_getlp:
inc bx
mov al,use[bx]
cmp al,0
jne _used
inc free
_used:
cmp bx,128
jne _getlp
popad
mov bx,hnd
shl bx,1
mov dx,len[bx]
mov ax,loc[bx]
mov bx,free
mov bh,ah
mov ax,1
iretd

_requmb:
xor ax,ax
mov bl,080h
iretd

_reqhma:
cmp ds:hma,1
je _hmaused
mov ax,1
xor bl,bl
mov ds:hma,1
iretd
_hmaused:
xor ax,ax
mov bl,091h
iretd

_relhma:
cmp ds:hma,1
jne _hmanotused
mov ax,1
xor bl,bl
mov ds:hma,0
iretd
_hmanotused:
xor ax,ax
mov bl,093h

iretd

_quea20:
xor ax,ax
mov al,a20en
xor bl,bl
iretd

_globena20:
jmp _globena20

_globdisa20:
jmp _locdisa20

_locena20:
inc a20count
cmp a20count,1
jne _nolocena20
pushad
call near ptr _enaa20
popad
_nolocena20:
mov ax,1
xor bl,bl
mov a20en,1
iretd

_locdisa20:
cmp a20count,0
jne _nodisa20
pushad
call near ptr _disa20
popad
jmp _skipdeca20
_nodisa20:
dec a20count
_skipdeca20:
mov ax,1
xor bl,bl
mov a20en,0
iretd

_lockxms:
pushad
mov cx,ax
mov hnd,dx
mov bx,dx
mov al,use[bx]
cmp al,1
je _lusedok
popad
xor ax,ax
mov bl,0A2h
iretd
_lusedok:
shl bx,1
mov word ptr loc[bx],1
movzx eax,sta[bx]
shl eax,10
add eax,xmsbase
mov lco,ax
shr eax,16
mov lcs,ax
popad
mov ax,1
mov dx,lcs
mov bx,lco
iretd

_unlockxms:
pushad
mov cx,ax
mov hnd,dx
mov bx,dx
mov al,use[bx]
cmp al,1
je _uusedok
popad
xor ax,ax
mov bl,0A2h
iretd
_uusedok:
shl bx,1
mov word ptr loc[bx],0
popad
mov ax,1
mov bl,0
iretd


_disa20:
mov edi,(0121000h+0100H*4)
mov eax,7
mov es:[edi],eax	;FFFF:0010 WILL POINTS TO 0
mov eax,0120000h
mov cr3,eax
retn

_enaa20:
mov edi,(0121000h+0100h*4)
mov eax,0100007h
mov es:[edi],eax
mov eax,0120000h
mov cr3,eax
retn

use db 130 dup (0)
sta dw 129 dup (0)
len dw 129 dup (0)
loc dw 129 dup (0)
freesize dw 2000
maxfree dw 0
position dw 0
free dw 0
largest dw 0
control db 0
max dw 2000
allocsize dw 0
hnd dw 0
movelen dd 0
sourceh dw 0
sourceo dd 0
desth dw 0
desto dd 0
hma db 0
a20en db 0
a20count db 0
lcs dw 0
lco dw 0
xmserr: db 'Unknown XMS command : ',0
